"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.parsePattern = void 0;
function parsePattern(pattern) {
    const splittedBySpace = pattern.split(' ');
    let results = {};
    if (!pattern || _hasAnyInvalidParam(splittedBySpace)) {
        return results;
    }
    splittedBySpace.forEach((rawParam, index) => {
        results = Object.assign(Object.assign({}, results), _mapParamToProperFormat(rawParam, index));
    });
    return results;
}
exports.parsePattern = parsePattern;
function _hasAnyInvalidParam(params) {
    const matchInvalidCharacters = /[^A-Za-z0-9_\[\]\<\>\@]+/;
    return params.some((param) => matchInvalidCharacters.test(param));
}
function _mapParamToProperFormat(param, patternIndex) {
    const argWithoutBrackets = _removeAllBrackets(param);
    const paramName = _clearParameterName(argWithoutBrackets);
    const isRequired = param.includes('<');
    const isVarargs = argWithoutBrackets.includes('@');
    return { [paramName]: { patternIndex, isRequired, isVarargs, signatureIndex: 0 } };
}
function _removeAllBrackets(value) {
    return value.replace(/\<|\>|\[|\]/g, '');
}
function _clearParameterName(param) {
    return param.replace('@', '');
}
//# sourceMappingURL=pattern.parser.js.map