"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.mapActualValueToParams = void 0;
function mapActualValueToParams(patternParams, actualParamsValues) {
    const mutablePatternParams = patternParams || [];
    const arrayMappedParams = Object.values(mutablePatternParams);
    return arrayMappedParams
        .sort(_ascendingBySignatureIndex)
        .map((arg) => (Object.assign(Object.assign({}, arg), { value: _getParamValue(arg, actualParamsValues) })));
}
exports.mapActualValueToParams = mapActualValueToParams;
function _getParamValue(arg, actualParamsValues) {
    return arg.isVarargs ? _joinVarargsIfPresent(actualParamsValues, arg) : _getNormalParam(actualParamsValues, arg);
}
function _joinVarargsIfPresent(actualValue, arg) {
    const chunkedVarargs = actualValue.slice(arg.patternIndex);
    return chunkedVarargs.length === 0 ? null : chunkedVarargs.join(' ');
}
function _getNormalParam(actualValue, arg) {
    return actualValue[arg.patternIndex] || null;
}
function _ascendingBySignatureIndex(a, b) {
    return a.signatureIndex - b.signatureIndex;
}
//# sourceMappingURL=value-to-param.mapper.js.map